
// Range slider

$wrapper-padding: 10px;

$thumb-size: 24px;
$thumb-width: $thumb-size;
$thumb-height: $thumb-size;
$thumb-color: #efefef;
$thumb-color-active: #e0e0e0;
$thumb-color-disabled: #c7c7c7;
$thumb-border-radius: 100%;;

$track-size: 4px;
$track-color: #616161;
$track-color-disabled: #616161;

$progress-color: #2196F3;
$progress-color-disabled: #a3a3a3;

$transition-duration: .2s;
$transition-timing: cubic-bezier(0.54, 0.28, 0.65, 0.85);

$container-size: $thumb-size;

$track-offset: $container-size / 2 - $track-size / 2;
$track-side-offset: $thumb-size / 2;

$thumb-box-shadow: 0 2px 5px 0 rgba(0, 0, 0, .16),
0 2px 10px 0 rgba(0, 0, 0, .12);

$thumb-box-shadow-hover: 0 4px 9px 0 rgba(0, 0, 0, .18),
0 4px 15px 0 rgba(0, 0, 0, .14);

$thumb-box-shadow-active: 0 2px 5px 0 rgba(0, 0, 0, .22),
0 2px 10px 0 rgba(0, 0, 0, .18);

.grsw,
.grsc,
.grstr,
.grspr,
.grsthc,
.grsth {
  display: block;
  margin: 0;
  padding: 0;
  box-sizing: border-box;
  -webkit-user-select: none;
  -khtml-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
  -webkit-tap-highlight-color: transparent;
}

.grsw {
  padding: $wrapper-padding;
  overflow: hidden;
  height: 100%;
}

.grsc {
  position: relative;
}

.grstr {
  position: absolute;
  border-radius: 100px;
  background-color: $track-color;
  cursor: pointer;
  -webkit-mask-image: -webkit-radial-gradient(white, black);
  mask-image: radial-gradient(white, black);
  transition: background-color $transition-duration $transition-timing;
}

.grspr {
  position: absolute;
  width: 100%;
  height: 100%;
  background-color: $progress-color;
  background-size: 100% 100%;
  transform-origin: 0 0 0;
  transition: background-color $transition-duration $transition-timing;
}

.grsthc {
  position: absolute;
}

.grsth {
  position: absolute;
  width: $thumb-width;
  height: $thumb-height;
  border-radius: $thumb-border-radius;
  background-color: $thumb-color;
  box-shadow: $thumb-box-shadow;
  cursor: pointer;
  transition:
    box-shadow $transition-duration $transition-timing,
    background-color $transition-duration $transition-timing;

  &:hover {
    box-shadow: $thumb-box-shadow-hover;
  }

  &:active {
    box-shadow: $thumb-box-shadow-active;
  }
}

.grshor {

  .grsc {
    width: 100%;
    height: $container-size;
  }

  .grstr {
    left: $thumb-width / 2;
    right: $thumb-width / 2;
    height: $track-size;
    top: $track-offset;
  }

  .grsthc {
    left: $thumb-width / 2;
    right: $thumb-width / 2;
    height: 0;
  }

  .grsth {
    left: -($thumb-width / 2);
    top: 0;
  }
}

.grsver {

  .grsc {
    width: $container-size;
    height: 100%;
  }

  .grstr {
    top: $thumb-height / 2;
    bottom: $thumb-height / 2;
    width: $track-size;
    left: $track-offset;
  }

  .grsthc {
    top: $thumb-height / 2;
    bottom: $thumb-height / 2;
    width: 0;
  }

  .grsth {
    top: -($thumb-height / 2);
    left: 0;
  }
}

.grsw.grs-a {

  .grsth {
    background-color: $thumb-color-active;
    box-shadow: $thumb-box-shadow-hover;
  }
}

.grsw.grs-dis {

  .grstr {
    cursor: default;
    background-color: $track-color-disabled;
  }

  .grspr {
    background-color: $progress-color-disabled;
  }

  .grsth {
    cursor: default;
    background-color: $thumb-color-disabled;
    box-shadow: $thumb-box-shadow;

    &:hover {
      box-shadow: $thumb-box-shadow;
    }

    &:active {
      box-shadow: $thumb-box-shadow;
    }
  }
}
